Name:		mongrel2
Version:	1.7
Release:	1%{?dist}
Summary:	A web server

Group:		System Environment/Daemons
License:	BSD
URL:		http://mongrel2.org/
Source0:	http://mongrel2.org/static/downloads/%{name}-%{version}.tar.bz2
Source1:	m2sh.1
Source2:	procer.1
Source3:	m2shpy.1
Source4:	mongrel2.8
# Make rpmlint happier about the choice of kegogi interpreter.
Patch:		mongrel2-1.5-kegogiexample.patch
BuildRoot:	%(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)

BuildRequires:	zeromq-devel sqlite-devel
#Requires:	

%description
An application, language, and network architecture agnostic web server
that focuses on web applications using modern browser technologies.

%package procer
Summary:	A user-space process manager
Group:		System Environment/Daemons

%description procer
A user-space process manager with dependency and privilege management,
originally designed for use as a Mongrel2 manager.

%package python
Summary:	Python interface for %{name}
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}
BuildArch:	noarch
BuildRequires:	python2-devel

%description python
This package contains a python interface for %{name}.

%prep
%setup -q
%patch -p1

# Fix permissions.
find examples -type f -exec chmod 0644 {} \;
find examples -type d -exec chmod 0755 {} \;

# Convert to UTF-8.
iconv -f iso8859-1 -t utf-8 examples/zcov/zcov/data/js/sorttable.js > examples/zcov/zcov/data/js/sorttable.js.conv && mv -f examples/zcov/zcov/data/js/sorttable.js.conv examples/zcov/zcov/data/js/sorttable.js

# Fix line-endings.
sed -i 's/\r//' docs/wiki/Donors.wiki
sed -i 's/\r//' docs/lt/wiki/Donors.wiki
sed -i 's/\r//' examples/bbs/client.py

# Remove zero-length file.
rm examples/chat/idiots


%build
#DESTDIR="${RPM_BUILD_ROOT}" PREFIX="%{_prefix}" CFLAGS="$RPM_OPT_FLAGS" OPTLIBS=-lpthread make %{?_smp_mflags}
DESTDIR="${RPM_BUILD_ROOT}" PREFIX="%{_prefix}" CFLAGS="$RPM_OPT_FLAGS" OPTLIBS=-lpthread make
pushd examples/procer
DESTDIR="${RPM_BUILD_ROOT}" PREFIX="%{_prefix}" CFLAGS="$RPM_OPT_FLAGS" make %{?_smp_mflags}
popd


%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR="$RPM_BUILD_ROOT" PREFIX="%{_prefix}"
mkdir -p $RPM_BUILD_ROOT/%{_sbindir}
mv $RPM_BUILD_ROOT/%{_bindir}/mongrel2 $RPM_BUILD_ROOT/%{_sbindir}/mongrel2

pushd examples/procer
make install DESTDIR="$RPM_BUILD_ROOT" PREFIX="%{_prefix}"
make clean
popd

strip -s -v %{buildroot}%{_bindir}/*
strip -s -v %{buildroot}%{_sbindir}/*

pushd examples/python
%{__python} setup.py install --root $RPM_BUILD_ROOT
%{__python} setup.py clean
popd

install -D -p -m 0644 %{SOURCE1} $RPM_BUILD_ROOT/%{_mandir}/man1/m2sh.1
install -D -p -m 0644 %{SOURCE2} $RPM_BUILD_ROOT/%{_mandir}/man1/procer.1
install -D -p -m 0644 %{SOURCE3} $RPM_BUILD_ROOT/%{_mandir}/man1/m2shpy.1
install -D -p -m 0644 %{SOURCE4} $RPM_BUILD_ROOT/%{_mandir}/man8/mongrel2.8

mkdir $RPM_BUILD_ROOT/%{_libdir}
mv $RPM_BUILD_ROOT/%{_prefix}/lib/mongrel2 $RPM_BUILD_ROOT/%{_libdir}/mongrel2


%clean
rm -rf $RPM_BUILD_ROOT


%files
%defattr(-,root,root,-)
%doc LICENSE examples docs
%{_bindir}/m2sh
%{_sbindir}/mongrel2
%{_mandir}/man1/m2sh.*
%{_mandir}/man8/mongrel2.*
%{_libdir}/mongrel2/config_modules/null.so
%{_libdir}/mongrel2/config_modules/zmq.so
%{_libdir}/mongrel2/filters/null.so

%files procer
%defattr(-,root,root,-)
%doc LICENSE
%{_bindir}/procer
%{_mandir}/man1/procer.*

%files python
%defattr(-,root,root,-)
%doc LICENSE
%{python_sitelib}/*
%{_bindir}/m2shpy
%{_mandir}/man1/m2shpy.*


%changelog
* Tue Jun  7 2011 Ed Marshall <esm@logic.net> - 1.7-1
- Update to 1.7.

* Wed Apr 13 2011 Ed Marshall <esm@logic.net> - 1.5-2
- Fix mock builds.

* Tue Apr 12 2011 Ed Marshall <esm@logic.net> - 1.5-1
- Initial version.
